--[[############################################################################################]]--
--[[                                                                                            ]]--
--[[  File     :  /maps/Seton's archipelago 2/Seton's archipelago 2_script.lua                  ]]--
--[[                                                                                            ]]--
--[[  Author(s):  SOKOL et Manimal (scripters)                                                  ]]--
--[[               ^Please note  that SOKOL came with original idea for this script but SOKOL's ]]--
--[[                script DID NOT work and was fixed by genius mind of Manimal.                ]]--
--[[                                                                                            ]]-- 
--[[  Version  :  1.01                                                                          ]]--
--[[                                                                                            ]]--
--[[  Date     :  30 octobre 2007                                                               ]]--
--[[                                                                                            ]]--
--[[  Summary  :  Seton's archipelago 2 Map Script (SUPREME COMMANDER 1.1.3269 and		]]--
--[[						    SUPREME COMMANDER: Forged Alliance ?.?.?    ]]--
--[[						     compatible) 				]]--
--[[                                                                                            ]]--
--[[############################################################################################]]--



--[[

Hi SOKOL,

Here is my version of your script that's respecting your scripting style as much as possible.

MakeEngineerLists has been completely changed for MakeEngineerGroups !

Your version of the function MakeEngineerLists() is WRONG :

 � Groups MUST contain UNITS that are TABLES (not markers or names) which ones are grouped in a single TABLE.

 � Groups of Units can be created DIRECTLY with the Official Scenario Editor by grouping units.

REMARK : I've edited your Map so that you have now those groups of engeeners ready for use (just in case ) !
         Now GROUPS are "ENG_D_PK_00", "ENG_D_PK_01", "ENG_D_PK_02", (etc...), "ENG_R_PK_01"


UNUSED Detailed Engineers Groups Table :
----------------------------------------
(this reflects the contents of "Seton's archipelago 2_save.lua" )

EngeenersGroupsFullTable = {

  groupName = "ENG_D_PK_00", unitNames = { "ENG_D_PK_00_00", "ENG_D_PK_00_01", "ENG_D_PK_00_02" },
  groupName = "ENG_D_PK_01", unitNames = { "ENG_D_PK_01_00", "ENG_D_PK_01_01", "ENG_D_PK_01_02" },
  groupName = "ENG_D_PK_02", unitNames = { "ENG_D_PK_02_00", "ENG_D_PK_02_01", "ENG_D_PK_02_02" },
  groupName = "ENG_D_PK_03", unitNames = { "ENG_D_PK_03_00", "ENG_D_PK_03_01", "ENG_D_PK_03_02" },
  groupName = "ENG_U_PK_00", unitNames = { "ENG_U_PK_00_00", "ENG_U_PK_00_01", "ENG_U_PK_00_02" },
  groupName = "ENG_U_PK_01", unitNames = { "ENG_U_PK_01_00", "ENG_U_PK_01_01", "ENG_U_PK_01_02" },
  groupName = "ENG_U_PK_02", unitNames = { "ENG_U_PK_02_00", "ENG_U_PK_02_01", "ENG_U_PK_02_02" },
  groupName = "ENG_U_PK_03", unitNames = { "ENG_U_PK_03_00", "ENG_U_PK_03_01", "ENG_U_PK_03_02" },
  groupName = "ENG_L_PK_00", unitNames = { "ENG_L_PK_00_00", "ENG_L_PK_00_01", "ENG_L_PK_00_02" },
  groupName = "ENG_L_PK_01", unitNames = { "ENG_L_PK_01_00", "ENG_L_PK_01_01", "ENG_L_PK_01_02" },
  groupName = "ENG_R_PK_00", unitNames = { "ENG_R_PK_00_00", "ENG_R_PK_00_01", "ENG_R_PK_00_02" },
  groupName = "ENG_R_PK_01", unitNames = { "ENG_R_PK_01_00", "ENG_R_PK_01_01", "ENG_R_PK_01_02" }
}


I've also made PATROLS in a more generic way by working with a table.

So now the script uses an EngeenersTable that has THREE fields : UnitsGroup, GroupName and PatrolChain !

This will be more convenient for Patrol Operations. See EngeenersTable below.

]]--




--[[ ####################### ]]--
--[[  D E F I N I T I O N S  ]]--
--[[ ####################### ]]--




local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import('/lua/ScenarioFramework.lua')
local Utilities = import('/lua/utilities.lua')




--[[                                                                               ]]--
--[[  EngeenersGroupsTable is used by the function MakeEngineersGroups             ]]--
--[[                                                                               ]]--
--[[  This ensures that spawned (from save.lua) units ONLY will be taken in count  ]]--
--[[                                                                               ]]--

EngeenersGroupsTable = {

  { UnitsGroup = {},	GroupName = "ENG_D_PK_00",	PatrolChain = "Patrol_chain_D_00" }, 
  { UnitsGroup = {},	GroupName = "ENG_D_PK_01",	PatrolChain = "Patrol_chain_D_01" },
  { UnitsGroup = {},	GroupName = "ENG_D_PK_02",	PatrolChain = "Patrol_chain_D_02" },
  { UnitsGroup = {},	GroupName = "ENG_D_PK_03",	PatrolChain = "Patrol_chain_D_03" },

  { UnitsGroup = {},	GroupName = "ENG_L_PK_00",	PatrolChain = "Patrol_chain_L_00" },
  { UnitsGroup = {},	GroupName = "ENG_L_PK_01",	PatrolChain = "Patrol_chain_L_01" },

  { UnitsGroup = {},	GroupName = "ENG_R_PK_00",	PatrolChain = "Patrol_chain_R_00" },
  { UnitsGroup = {},	GroupName = "ENG_R_PK_01",	PatrolChain = "Patrol_chain_R_01" },

  { UnitsGroup = {},	GroupName = "ENG_U_PK_00",	PatrolChain = "Patrol_chain_U_00" },
  { UnitsGroup = {},	GroupName = "ENG_U_PK_01",	PatrolChain = "Patrol_chain_U_01" },
  { UnitsGroup = {},	GroupName = "ENG_U_PK_02",	PatrolChain = "Patrol_chain_U_02" },
  { UnitsGroup = {},	GroupName = "ENG_U_PK_03",	PatrolChain = "Patrol_chain_U_03" }
}


MilitaryLandPatrolTable0 = {

  { UnitsGroup = {},	GroupName = "LIGHT_GR_L0",	PatrolChain = "MIPC_00" }, 
  { UnitsGroup = {},	GroupName = "LIGHT_GR_L1",	PatrolChain = "MIPC_00" }, 
  { UnitsGroup = {},	GroupName = "LIGHT_GR_R0",	PatrolChain = "MIPC_00" }, 
  { UnitsGroup = {},	GroupName = "LIGHT_GR_R1",	PatrolChain = "MIPC_00" }, 

}


MilitaryNavalPatrolTable0 = {
  { UnitsGroup = {},	GroupName = "NP_0",	PatrolChain = "NP_0_C_0" }, 
  { UnitsGroup = {},	GroupName = "NP_1",	PatrolChain = "NP_1_C_0" }, 

}






--[[ ###################### ]]--
--[[   STARTER  FUNCTIONS   ]]--
--[[ ###################### ]]--




function OnPopulate()

	ScenarioUtils.InitializeArmies()

	ExtraInit() 			#SOKOL's note: ExtraInit() runs custom script
end





function OnStart(self)

end




--[[ ##################### ]]--
--[[   CUSTOM  FUNCTIONS   ]]--
--[[ ##################### ]]--




ExtraInit = function()
	GiveMissilesToArmy( "ARMY_9", 5 )
	OrderArmyToBuildMissiles("ARMY_9", true)

	ActivatePatrols()
	InitScoreCounter()
end




GiveMissilesToArmy = function( armyStr, ammo )
	GiveAntiNukesToArmy( armyStr, ammo )
	GiveTactAmmoToArmy( armyStr, ammo )
end




GiveAntiNukesToArmy = function( armyStr, numAntiNukesPerSilo )
	BuildTacticalMissiles( armyStr, numAntiNukesPerSilo, categories.ueb4302 )
end




GiveTactAmmoToArmy = function( armyStr, numTacticalMissiles )
	BuildTacticalMissiles( armyStr, numTacticalMissiles, categories.ueb2108 )
	BuildTacticalMissiles( armyStr, 1, categories.ues0304 )
end



OrderArmyToBuildMissiles = function( armyStr, boolAuto )
	OrderUnitsToBuildMissiles(armyStr, categories.ueb2108, boolAuto)
	OrderUnitsToBuildMissiles(armyStr, categories.ueb4302, boolAuto)
	OrderUnitsToBuildMissiles(armyStr, categories.ues0304, boolAuto)
end




OrderUnitsToBuildMissiles = function(armyStr, categoryToBuild, boolAuto)
	local brain = GetArmyBrain (armyStr)
	local unitsList = brain:GetListOfUnits(categoryToBuild, false)

	for i, unit in unitsList do 
		if unit and ( unit != nil ) and not unit:IsDead() then
			unit:SetAutoMode( boolAuto )
			LOG("MANIMAL:   Autobuild missile")
		else
			error('MANIMAL:  *ERROR* Attempting to build Missiles in a non-existent unit ')
		end 
	end 

end



--[[                                                                 ]]-- 
--[[  BuildTacticalMissiles( armyStr, numToBuild, categoryToBuild )  ]]-- 
--[[                                                                 ]]-- 
--[[  GENERIC function  for Tactical and Anti-Nukes silos            ]]-- 
--[[                                                                 ]]-- 
--[[  fills up silos with ammo                                       ]]-- 
--[[                                                                 ]]-- 

BuildTacticalMissiles = function( armyStr, numToBuild, categoryToBuild )

	local ammo = MATH_IRound( tonumber( numToBuild ) )  # keep INTEGRAL part ONLY 
							    #SOKOL's note: or round it to the nearest integer?

	if ammo < 0 then
		ammo = 0
	end

	local brain = GetArmyBrain( armyStr )

        # e.g. brain:GetListOfUnits( entityCategory, needToBeIdle )
        local unitsList = brain:GetListOfUnits( categoryToBuild, false )

	for i, unit in unitsList do 
		if unit and ( unit != nil ) and not unit:IsDead() then
			unit:GiveTacticalSiloAmmo( ammo )
			unit:SetAutoMode( true )
			LOG("MANIMAL:   Missiles Silo Ammo = "..ammo.."  .")
		else
			error('MANIMAL:  *ERROR* Attempting to build Missiles in a non-existent unit ')
		end 
	end 

end




GiveNukes = function( armyStr, numTobuild, categoryToBuild )
	local ammo = MATH_IRound( tonumber( numToBuild ) )  # keep INTEGRAL part ONLY 
							    #SOKOL's note: or round it to the nearest integer?

	if ammo < 0 then
		ammo = 0
	end

	local brain = GetArmyBrain( armyStr )

        # e.g. brain:GetListOfUnits( entityCategory, needToBeIdle )
        local unitsList = brain:GetListOfUnits( categoryToBuild, false )

	for i, unit in unitsList do 
		if unit and ( unit != nil ) and not unit:IsDead() then
			unit:GiveNukeSiloAmmo(ammo)
			unit:SetAutoMode( true )
			LOG("MANIMAL:   Missiles Silo Ammo = "..ammo.."  .")
		else
			error('MANIMAL:  *ERROR* Attempting to build Missiles in a non-existent unit ')
		end 
	end 

end


--[[                                                 ]]--
--[[  ActivatePatrols()                              ]]--
--[[                                                 ]]--
--[[  Uses EngeenersGroupsTable which contains       ]]--
--[[  ALL engeeners groups                           ]]--
--[[                                                 ]]--
--[[                                                 ]]--

ActivatePatrols = function()

	MakeEngineersGroups( categories.uel0309, "ARMY_9", EngeenersGroupsTable, 11 )
	ActivateEngineerPatrols( EngeenersGroupsTable )

	MakeGroups(( categories.uel0104 + categories.uel0106 ), "ARMY_9", MilitaryLandPatrolTable0, 11 )
	ActivatePatrol(MilitaryLandPatrolTable0)

	MakeGroups(( categories.ues0203 + categories.ues0201 + categories.ues0202 + categories.ues0302 + categories.ues0304 ), "ARMY_9", MilitaryNavalPatrolTable0, 4)
	ActivatePatrol(MilitaryNavalPatrolTable0)
end


MakeGroups = function( entityCategory, strArmy, table, nameNum )
	MakeEngineersGroups( entityCategory, strArmy, table, nameNum ) 
end



--[[                                                                      ]]--
--[[  MakeEngineersGroups( entityCategory, strArmy, table )               ]]--
--[[                                                                      ]]--
--[[  function that fills up the fields UnitsGroup                        ]]--
--[[                                                                      ]]--
--[[  e.g. MakeEngineersGroups( categories.uel0104, "ARMY_9" )            ]]--
--[[                                                                      ]]--

MakeEngineersGroups = function( entityCategory, strArmy, table, nameNum)

# Warning: this function alters the global variable EngeenersGroupsTable

# table format reminder: {UnitsGroup = {}, GroupName = "ENG_D_PK_00", PatrolChain = "Patrol_chain_D_00"} 

	local groupIndex    = 1

        if strArmy and ( strArmy != "" ) then

		for i, engGroup in pairs ( table ) do	# e.g. groupName = "ENG_U_PK_01"

			local unitsGroup = {}

			unitsGroup = MakeUnitsGroup( entityCategory, strArmy, engGroup.GroupName, nameNum )

			if unitsGroup and ( unitsGroup != nil ) then

				table[groupIndex].UnitsGroup = unitsGroup	# store each group in allgroups table

				groupIndex  = groupIndex + 1

				LOG("MANIMAL:  Group "..engGroup.GroupName.." number "..groupIndex.." added to EngeenersGroupsTable  .")

			else
				error("MANIMAL:  *ERROR* Attempting to add a non-existent group  .")
			end
		end
	end

--[[ 
	LOG( " " )
	LOG( "MANIMAL  :  DEBUG  EngeenersGroupsTable = ")
	LOG( " " )
	LOG( repr( EngeenersGroupsTable ) )
	LOG( " " )
	LOG( "MANIMAL  :  DEBUG  FIN DE TABLE " )
]]--

end






--[[                                                                      ]]--
--[[  MakeUnitsGroup( entityCategory, strArmy, groupName  )               ]]--
--[[                                                                      ]]--
--[[  function that creates and return a UnitsGroup                       ]]--
--[[                                                                      ]]--
--[[  e.g. MakeUnitsGroup( categories.uel0309, "ARMY_9", "ENG_R_PK_01" )  ]]--
--[[                                                                      ]]--

MakeUnitsGroup = function( entityCategory, strArmy, groupName, afterNum )

	local unitsGroup = {}
	local unitIndex  = 1
	local unitName = ""

	local brain = GetArmyBrain( strArmy )
        local unitsList = brain:GetListOfUnits( entityCategory, false )

        if groupName and ( groupName != "" ) then

		for i, unit in unitsList do

			unitName = ""

			if unit and ( unit != nil ) and not unit:IsDead() then

			# e.g. unit.UnitName = "ENG_U_PK_01_01" so ExtractGroupName should return "ENG_U_PK_01"

				unitName = ExtractGroupName( unit.UnitName, afterNum)

				if  unitName == groupName then		# keep the matching unit names ONLY

					unitsGroup[unitIndex] = unit
					unitIndex = unitIndex + 1

					LOG("MANIMAL:  Unit "..unit.UnitName.." number "..unitIndex.." added to the Group  "..groupName.."  .")

				end
			else
				error("MANIMAL:  *ERROR* Attempting to add a non-existent unit  .")
			end
		end
	end

	return unitsGroup
end




--[[                                                                             ]]--
--[[   ExtractGroupName( unitName, afterNum )                                    ]]--
--[[                                                                             ]]--
--[[   Copy "aaa_a_aa_xx" from "aaa_a_aa_xx_xx"   (characters 1 to 11)           ]]--
--[[                                                                             ]]--

ExtractGroupName = function( unitName, afterNum )

    --[[  string.sub (s, i [, j]) from LUA  Guide  ]]--

    return ( string.sub( unitName, 1, math.abs(MATH_IRound( tonumber( afterNum ) )))  or "" )

end




--[[                                                   ]]--
--[[  ActivateEngineerPatrols( engeenersGroupsTbl )    ]]--
--[[                                                   ]]--
--[[                                                   ]]--
--[[                                                   ]]--

ActivateEngineerPatrols = function( engeenersGroupsTbl )

# table format reminder: UnitsGroup = {}, GroupName = "ENG_D_PK_00", PatrolChain = "Patrol_chain_D_00", 

	local chainToPosPatrolChain = false

	for i, engGroup in pairs( engeenersGroupsTbl ) do

		if engGroup.PatrolChain and ( engGroup.PatrolChain != nil ) then

			chainToPosPatrolChain = ScenarioUtils.ChainToPositions( engGroup.PatrolChain )
			StartPatrol( engGroup.UnitsGroup, chainToPosPatrolChain )
		end
	end

end





--[[                                                   ]]--
--[[SOKOL:					       ]]--
--[[  ActivatePatrol( tbl )			       ]]--
--[[                                                   ]]--
--[[                                                   ]]--
ActivatePatrol = function( tbl )
	ActivateEngineerPatrols( tbl )
end




--[[                                                              ]]-- 
--[[  StartPatrol( unitsGroup, chainToPosPatrolChain )            ]]-- 
--[[                                                              ]]-- 
--[[                                                              ]]-- 
--[[                                                              ]]-- 

StartPatrol = function( unitsGroup, chainToPosPatrolChain )

        # IssuePatrol is expecting a TABLE of UNITS (not a chain !) and a Patrol Chain.

	for k, v in chainToPosPatrolChain do
		IssuePatrol( unitsGroup, v )
	end
end




--[[                                                             ]]-- 
--[[  The function InitScoreCounter() WAS COMPLETELY WRONG  !!!  ]]-- 
--[[  Compare our respective codes...                            ]]-- 
--[[                                                             ]]-- 

InitScoreCounter = function()

	local tblArmy = ListArmies()

	for k, strArmy in pairs(tblArmy) do			# For EACH Army found in tblArmy

		local tblData = Scenario.Armies[strArmy]	# Read the Data from the currently pointed Army ( through strArmy )

		if tblData then					# Set Economy for the currently pointed Army ( through strArmy )

			SetArmyEconomy( strArmy, tblData.Economy.mass, tblData.Economy.energy )
		end
	end
end




--[[###############################]]--
--[[   E N D   O F   S C R I P T   ]]--
--[[###############################]]--


